Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0045005
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Openbravo ERP] A. Platformcriticalalways2020-09-07 15:412020-09-09 09:20
ReportermalsasuaView Statuspublic 
Assigned Tocaristu 
PrioritynormalResolutionfixedFixed in VersionPR20Q4
StatusclosedFix in branchFixed in SCM revision
ProjectionnoneETAnoneTarget Version
OSAnyDatabaseAnyJava version
OS VersionDatabase versionAnt version
Product VersionSCM revision 
Review Assigned To
Web browser
ModulesCore
Regression level
Regression date
Regression introduced in release
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0045005: In HA environments Data Import Entry processor is executed in the two nodes simultaneously

DescriptionIn environments with more than one tomcat node, in some cases, the Data Import Entry processor can be executed at the same time in the two nodes
Steps To ReproduceWe have found the problem in environments with database locks (attachment1)
See one example: attachment2

For this case, it seems that only during 16 seconds, the records were processed simultaneously
TagsNo tags attached.
Attached Filespng file icon db_locks.png [^] (86,797 bytes) 2020-09-07 15:41


log file icon example.log [^] (68,377 bytes) 2020-09-07 15:41

- Relationships Relation Graph ] Dependency Graph ]
depends on backport 0045011PR20Q3.1 closedcaristu In HA environments Data Import Entry processor is executed in the two nodes simultaneously 
depends on backport 0045012PR20Q2.2 closedcaristu In HA environments Data Import Entry processor is executed in the two nodes simultaneously 

-  Notes
(0122805)
hgbot (developer)
2020-09-08 18:10

Merge Request created: https://gitlab.com/openbravo/product/openbravo/-/merge_requests/152 [^]
(0122852)
hgbot (developer)
2020-09-09 09:20

Merge request merged: https://gitlab.com/openbravo/product/openbravo/-/merge_requests/152 [^]
(0122853)
hgbot (developer)
2020-09-09 09:20

Directly closing issue as related merge request is already approved.

Repository: https://gitlab.com/openbravo/product/openbravo [^]
Changeset: 3f3600da371663ecc80dce4fa215a6138bd11e11
Author: Carlos Aristu <carlos.aristu@openbravo.com>
Date: 2020-09-09T09:20:11+02:00
URL: https://gitlab.com/openbravo/product/openbravo/-/commit/3f3600da371663ecc80dce4fa215a6138bd11e11 [^]

fixes ISSUE-45005: can have two leader nodes at the same time

   In case of having a database lock in the AD_CLUSTER_SERVICE table,
the nodes of the HA clustered environment are not able to update
properly the last ping information. This may cause that during a period
of time several nodes of the claster to wrongly take the leadership.

  The database lock causes the nodes to detect that the leader is no longer
available and to try to register themselves as leaders which will not
be possible while the table is locked.

  Once the lock is resolved, the different updates from the nodes will
be executed, causing a temporary wrong registration of one of the nodes as
leader.

  To avoid this wrong registration (update) in the table, we are going
to take into account the last ping seeing by each node when updating the
record. Thus, when the lock is resolved the leader update will be
commited updating the last ping value. Then, the rest of nodes will not
be able to update the record as the change in the last ping value will
make their update where clause not be fullfiled.

  Together with this change, we are removing some empty comments used to
format and removing a no longer needed string concatenation for logging.

---
M src/org/openbravo/cluster/ClusterServiceManager.java
---

- Issue History
Date Modified Username Field Change
2020-09-07 15:41 malsasua New Issue
2020-09-07 15:41 malsasua Assigned To => platform
2020-09-07 15:41 malsasua File Added: db_locks.png
2020-09-07 15:41 malsasua Modules => Core
2020-09-07 15:41 malsasua Triggers an Emergency Pack => No
2020-09-07 15:41 malsasua File Added: example.log
2020-09-08 18:10 hgbot Note Added: 0122805
2020-09-09 07:07 alostale Assigned To platform => caristu
2020-09-09 07:07 alostale Severity major => critical
2020-09-09 07:07 alostale Status new => scheduled
2020-09-09 09:20 hgbot Resolution open => fixed
2020-09-09 09:20 hgbot Status scheduled => closed
2020-09-09 09:20 hgbot Note Added: 0122852
2020-09-09 09:20 hgbot Fixed in Version => PR20Q4
2020-09-09 09:20 hgbot Note Added: 0122853


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker